﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.Framework.AppStyling;
using System.Drawing;
using Infragistics.Web.UI.Framework.Data;
using System.Collections;

public partial class _Default : System.Web.UI.Page
{
    
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebDataGrid1.DataSource = People;  
    }

    public IList<Person> People
    {
        get
        {
            if (Session["pp"] == null)
            {
                List<Person> people = new List<Person>();
                for (int r = 1; r < 100; ++r)
                {
                    if (r % 3 == 0)
                        people.Add(new Person(r, DateTime.Today.AddDays(r), "Name" + r, null, 123.4));
                    else
                        people.Add(new Person(r, DateTime.Today.AddDays(r)/**/, "Name" + r, r % 2 == 0, 123.4 * r));
                    if (r == 3)
                        people.Last().Name = "This is going to be very, very, very loooooooooooooooooonggg text!~!  hahahaha.";

                    people.Last().ExtraName = "hey";
                }
                Session["pp"] = people;
            }
            return Session["pp"] as IList<Person>;
        }
        set
        {
            Session["pp"] = value;
        }
    }

    public class Person
    {
        public int Id { get; set; }
        public DateTime? BirthDate { get; set; }
        public string Name { get; set; }
        public bool? IsActive { get; set; }
        public double Salary { get; set; }
        public string ExtraName { get; set; }

        public Person(int i, DateTime? d, string s, bool? b, double salary)
        {
            Id = i;
            BirthDate = d;
            Name = s;
            IsActive = b;
            Salary = salary;
        }

        public Person()
        {
        }
    }

    protected void FixBtn_Click(object sender, EventArgs e)
    {
        this.WebDataGrid1.Behaviors.ColumnFixing.FixedColumns.Add("IsActive");
        this.WebDataGrid1.Behaviors.ColumnFixing.FixedColumns.Add("Name");
    }

    protected void InsertBtn_Click(object sender, EventArgs e)
    {

        for (int x = 0; x < this.WebDataGrid1.Columns.Count; x++)
        {
            ((IVisibleItem)this.WebDataGrid1.Columns[x]).VisibleIndex = -1;
        }

        for (int i = 0; i < 20; i++)
        {
            UnboundCheckBoxField field = new UnboundCheckBoxField();
            field.Key = "UnbCheck " + i.ToString();
            this.WebDataGrid1.Columns.Insert(0, field);
            field.Header.Text = "unbound checkbox " + i.ToString();
        }

        int index = 2;

        for (int j = 0; j < this.WebDataGrid1.Columns.Count; j++)
        {
            if ((this.WebDataGrid1.Columns[j].Key != "IsActive") &&
            this.WebDataGrid1.Columns[j].Key != "Name")
            {               
                this.WebDataGrid1.Columns[j].VisibleIndex = index;
                index++;
            }
        }
    }
}   
